/*
 *  file.h
 *
 *  Created by samel on 17/05/07.
 *  Copyright 2007 DoNotJava. All rights reserved.
 *
 */

//brief: debug trick
#ifdef DEBUG_FILE_ENABLE
#define DEBUG_FILE(S,A) {_set_color(S,VIOLET,BLACK);_print A;_set_color(S,GREY,BLACK);}
#else
#define DEBUG_FILE(S,A)
#endif

#define MY_LIST   0
#define YOUR_LIST 1

#define FILE_NAME "filename.ext"
//#define FILE_NAME "filehalf.ext"

struct dummy_shalist
{
 char sha[40];
 char rate;
};
typedef struct dummy_shalist shalist;

/*
 brief: initialize the SD fat driver
 return: 1 if succesfully, 0 otherwise
 */
int _fat_init(void);

/*
 brief: deinitialize the SD fat driver
 return: 1 if succesfully, -1 otherwise
 */
int _fat_deinit(void);

/*
 brief:
 param: what,
 param: file,
 return:
 */
int _load_sha(int what,unsigned char* file);

/*
 brief:
 param: what,
 param: container,
 param: value
 return:
 */
int _read_sha(int what,char* container,char* value);

/*
 brief: open a file for save the received SHA codes
 param: mac, file name
 return: 1 if succesfully, -1 otherwise
 */
int _open_sha_recv(unsigned char* mac);

/*
 brief: close the file conteining the received SHA codes
 return: 1 if succesfully, -1 otherwise
 */
int _close_sha_recv(void);

/*
 brief: write the next SHA code to file
 param: container, buffer containing the SHA code
 param: value, buffer containing file rate
 return: 1 if succesfully, -1 otherwise
 */
int _write_sha_recv(char* container,char* value);

/*
 brief: return my shalist length
 return: shalist length
 */
int _get_my_length(void);

/*
 brief: return your shalist length
 return: shalist length
 */
int _get_your_length(void);
