/*
 *  interrupt.h
 *
 *  Created by samel on 16/05/07.
 *  Copyright 2007 DoNotJava. All rights reserved.
 *
 */

//brief: debug trick
#ifdef DEBUG_INTERRUPT_ENABLE
#define DEBUG_INTERRUPT(S,A) {_set_color(S,RED,BLACK);_print A;_set_color(S,GREY,BLACK);}
#else
#define DEBUG_INTERRUPT(S,A)
#endif

//brief: display system register
#define DISP_SR			(*(vuint16*)0x04000004)

/*
 brief: disable and save the interrupt system
 return: old REG_IME value
 */
int _disable_interrupt(void);

/*
 brief: enable and save the interrupt system
 return: old REG_IME value
 */
int _enable_interrupt(void);

/*
 brief: restore the saved the interrupt system
 param: old_ime, value to put in REG_IME
 */
void _restore_interrupt(int old_ime);

/*
 brief: initializes the timer interrupt to no timer handle
 return: always 1
 */
int _irq_init(void);

/*
 brief: initialize the vertical blank interrupt
 return: 1 on interrupt enabled, -1 otherwise
 */
int _vbi_init(void);
