/*
 *  network.h
 *
 *  Created by samel on 12/05/07.
 *  Copyright 2007 DoNotJava. All rights reserved.
 *
 */

//brief: debug trick
#ifdef DEBUG_NETWORK_ENABLE
#define DEBUG_NETWORK(S,A) {_set_color(S,BLUE,BLACK);_print A;_set_color(S,GREY,BLACK);}
#else
#define DEBUG_NETWORK(S,A)
#endif

/*
 brief: initialize the network system
 return: 1 if successfully connection to ssid, -1 otherwise
 */
int _network_init(void);

/*
 brief: connect to AP
 return: 1 if successfully connection to ssid, -1 otherwise
 */
int _connect(void);

/*
 brief: deinitialize the network system and the sockets handler
 return: always 1
 */
int _network_deinit(void);

/*
 brief: return the AP network signal
 return: AP network signal percentual
 */
int _get_network_signal(void);

/*
 brief: initialize the sockets used in recommendation
 return: 1 if all socket where created successfully, -1 otherwise
 */
int _socket_init(void);

/*
 brief: update internal wifi
 */
void _wifi_timer(void);

/*
 brief: get local ssid
 return: pointer to local ssid
 */
char* _get_local_ssid(void);

/*
 brief: get local mac address
 return: pointer to local mac address
 */
unsigned char* _get_local_mac(void);

/*
 brief: get local ip
 return: local ip number in inet_addr form
 */
char* _get_local_ip(void);

/*
 brief: get local mask
 return: local mask number in inet_addr form
 */
char* _get_local_mask(void);
