/*
 *  interrupt.c
 *
 *  Created by samel on 16/05/07.
 *  Copyright 2007 DoNotJava. All rights reserved.
 *
 */

#include "header.h"
#include <nds.h>
#include "interrupt.h"
#include "io.h"

//------------------------------------------------------------------------------
int _disable_interrupt()
{
 //DEBUG_INTERRUPT(UPPER,(UPPER,"-Interrupt disabled")); //cause screen glitch and ds freeze
	int a;
	a=REG_IME;
	REG_IME=0;
	return a;
}
//------------------------------------------------------------------------------
int _enable_interrupt()
{
 //DEBUG_INTERRUPT(UPPER,(UPPER,"-Interrupt enabled")); //cause screen glitch and ds freeze
	int a;
	a=REG_IME;
	REG_IME=1;
	return a;
}
//------------------------------------------------------------------------------
void _restore_interrupt(int old_ime)
{
 //DEBUG_INTERRUPT(UPPER,(UPPER,"-Interrupt restored")); //cause screen glitch
	REG_IME=old_ime;
}
//------------------------------------------------------------------------------
int _irq_init(void)
{
 DEBUG_INTERRUPT(UPPER,(UPPER,"IRQ initialization\n"));
 irqInit();
 return 1;
}
//------------------------------------------------------------------------------
int _vbi_init(void)
{
 DEBUG_INTERRUPT(UPPER,(UPPER,"VBI initialization\n"));
 REG_IME = 0;
 //if IRQ_VBLANK is disabled
 if(((REG_IE)&(IRQ_VBLANK))!=IRQ_VBLANK)
 {
  REG_IE = IRQ_VBLANK;
  REG_IF = ~0;
  DISP_SR = DISP_VBLANK_IRQ;
  REG_IME = 1;
  return 1;
 }
 DEBUG_INTERRUPT(UPPER,(UPPER,"vbi error\n"));
 //IRQ_VBLANK already enabled
 REG_IME = 1;
 return -1;
}
