/*
 *  timer.c
 *
 *  Created by samel on 12/05/07.
 *  Copyright 2007 DoNotJava. All rights reserved.
 *
 */

#include "header.h"
#include <nds.h>
#include "timer.h"
#include "io.h"

//brief: timeout variable
int _time_out=0;

//------------------------------------------------------------------------------
int _timer_start(int number,int freq,int div,void* function)
{
 DEBUG_TIMER(UPPER,(UPPER,"Timer start %d\n",number));
 //if timer is disabled
 if((TIMER_CR(number)&(TIMER_ENABLE))!=TIMER_ENABLE)
 {
  irqSet((1<<(number+3)),function);
  switch(div)
  {
   case DIV1:
    TIMER_DATA(number)=TIMER_FREQ(freq);
    break;
   case DIV64:
    TIMER_DATA(number)=TIMER_FREQ_64(freq);
    break;
   case DIV256:
    TIMER_DATA(number)=TIMER_FREQ_256(freq);
    break;
   case DIV1024:
    TIMER_DATA(number)=TIMER_FREQ_1024(freq);
    break;
  }
  TIMER_CR(number)=TIMER_ENABLE | TIMER_IRQ_REQ | div;
  return 1;
 }
 DEBUG_TIMER(UPPER,(UPPER,"timer error %d\n",number));
 //timer already started
 return -1;
}
//------------------------------------------------------------------------------
int _timer_stop(int number)
{
 DEBUG_TIMER(UPPER,(UPPER,"Timer stop %d\n",number));
 //if timer is enabled
 if((TIMER_CR(number)&(TIMER_ENABLE))==TIMER_ENABLE)
 {
  TIMER_CR(number)&=~(TIMER_ENABLE);
  return 1;
 }
 DEBUG_TIMER(UPPER,(UPPER,"timer error %d\n",number));
 //timer already stopped
 return -1;
}
//------------------------------------------------------------------------------
void _set_time_out(void)
{
 _time_out=0;
}
